#ifndef HEADER_CHANNEL
#define HEADER_CHANNEL

#include "illist.h"
#include "nick.h"
#include "defines.h"

class tchan {
  public:
    int ison;
    ilist<tnick> nicklist;
    char pathname[20];
    int modes[52]; /* 0-25 for lowercase modes, 26-51 for uppercase modes. */
    int numops;
    int numvoice;
    int numother;
    char name[CHANNAMELEN+1];
    int limit;
    char keyword[IRCMAXLEN];
    char *topic;
    int operator==(tchan &chan);
    int operator>=(tchan &chan);
    tchan(const char *);
    tchan();
    int addnicks(char *);
    int addnick(char *);
    int delnick(char *);
    int updatenicklist();
    int clearnicklist();
    int changenick(char *, char *);
    void deop(char *);
    void op(char *);
    void devoice(char *);
    void voice(char *);
    void setmode(char, int);
    int getmode(char);
    void clearmodes(void);
    ~tchan();
};

#endif
